require 'Command'
class BaseClassRegi
	
	@regiCommandLine = nil
	@userStoreCommandLine = nil

	@regiStringFormation = nil
	@userStoreStringFormation = nil

	@workspaceWorkingDirectory = nil
	@workspaceFolderName = nil

	@hdbuserstoreUser = nil
	@hdbuserstorePassword = nil
	@hdbuserstoreHost = nil
	@hdbuserstorePort = nil
	@hdbuserstoreKey = nil

	@packageName = nil
	@mPackageNames = nil
	@subPackages = nil
	@deliveryUnit = nil
	@deliveryUnitVendor = nil
	@deliveryUnitVersion = nil
	@deliveryUnitVersionSP = nil
	@deliveryUnitVersionPatch = nil

# getter/setter methods	

	def sethdbUserstoreKey (hanaUserstoreKey)

		@hdbuserstoreKey = hanaUserstoreKey
	end

	public :sethdbUserstoreKey

	def gethdbUserstoreKey

		return @hdbuserstoreKey
	end

	public :gethdbUserstoreKey

	def setPackageName (packageName)

		@packageName = packageName
	end

	public :setPackageName

	def getPackageName

		return @packageName
	end

	public :setPackageName

	def setSystemDetails (username,password,host,port)

		@hdbuserstoreUser = username
		@hdbuserstorePassword = password
		@hdbuserstoreHost = host
		@hdbuserstorePort = port
	end

	public :setSystemDetails

	def setPackageNames (packageNames)
	
		@mPackageNames = packageNames
	end

	public :setPackageNames

	def getPackageNames
	
		return @mPackageNames
	end

	public :getPackageNames

	def setSubPackagesConsidered (subPackIndc)

		@subPackages = subPackIndc
	end

	public :setSubPackagesConsidered

	def IsSubPackagesConsidered

		return @subPackages
	end

	public :IsSubPackagesConsidered

	def setDeliveryUnit (deliveryUnit)

		@deliveryUnit = deliveryUnit
	end

	public :setDeliveryUnit

	def getDeliveryUnit

		return @deliveryUnit
	end

	public :getDeliveryUnit

	def setDeliveryUnitVendor (deliveryUnitVendor)

		@deliveryUnitVendor = deliveryUnitVendor
	end

	public :setDeliveryUnitVendor

	def getDeliveryUnitVendor

		return @deliveryUnitVendor
	end

	public :getDeliveryUnitVendor

	def setDeliveryUnitVersion (deliveryUnitVersion)
		@deliveryUnitVersion = deliveryUnitVersion
	end

	public :setDeliveryUnitVersion

	def getDeliveryUnitVersion
		return @deliveryUnitVersion
	end

	public :getDeliveryUnitVersion

	def setDeliveryUnitVersionSP (deliveryUnitVersionSP)
		@deliveryUnitVersionSP = deliveryUnitVersionSP
	end

	public :setDeliveryUnitVersionSP

	def getDeliveryUnitVersionSP
		return @deliveryUnitVersionSP
	end

	public :getDeliveryUnitVersionSP

	def setDeliveryUnitVersionPatch (deliveryUnitVersionPatch)
		@deliveryUnitVersionPatch = deliveryUnitVersionPatch
	end

	public :setDeliveryUnitVersionPatch

	def getDeliveryUnitVersionPatch
		return @deliveryUnitVersionPatch
	end

	public :getDeliveryUnitVersionPatch

	def initCommandLine
		if @regiStringFormation.nil?
			@regiStringFormation = 'regi'
		end
		if @userStoreStringFormation.nil?
			@userStoreStringFormation = 'hdbuserstore'
		end
		if @workspaceWorkingDirectory.nil?
			@workspaceWorkingDirectory = Dir.pwd
		end
		if @workspaceFolderName.nil?
			@workspaceFolderName = '.regi'
		end
	end

	protected :initCommandLine

	def executeRegiCommandLine (arguments)

		return executeRegiCommandLineHandleException(arguments,true)
	end

	protected :executeRegiCommandLine

	def executeRegiCommandLineHandleException (arguments,ignoreException)

		@commandLineString = ''
		count = 0

		while  count<arguments.length do
			if count!=arguments.length-1
				@commandLineString = @commandLineString + arguments[count] + ' '
			else
				@commandLineString = @commandLineString + arguments[count]
			end
			count = count + 1
		end

		@regiCommandLine = Command.run(@regiStringFormation + ' ' + @commandLineString)
		if @regiCommandLine.success?
			return @regiCommandLine.success?
		else
			if ignoreException
				return @regiCommandLine.success?
			else
				return 	@regiCommandLine.stderr
			end
		end
	end

	private :executeRegiCommandLineHandleException

	def executeRegiCommandLineWithOutput (arguments)

		return executeRegiCommandLineWithOutputHandleException(arguments,true)
	end

	protected :executeRegiCommandLineWithOutput

	def executeRegiCommandLineWithOutputHandleException (arguments,ignoreException)

		@commandLineString = ''
		count = 0

		while count<arguments.length do
			if count!=arguments.length-1
				@commandLineString = @commandLineString + arguments[count] + ' '
			else
				@commandLineString = @commandLineString + arguments[count]
			end
			count = count + 1
		end

		@regiCommandLine = Command.run(@regiStringFormation + ' ' + @commandLineString)
		if @regiCommandLine.success?
			return @regiCommandLine.stdout
		else
			if ignoreException
				return false
			else
				return @regiCommandLine.stderr
			end
		end
	end

	private :executeRegiCommandLineWithOutputHandleException

	def executeUserstoreCommandLine (arguments)

        @UserstoreString = ''
        count = 0

        while count<arguments.length do
            if count!=arguments.length-1
                @UserstoreString = @UserstoreString + arguments[count] + ' '
            else
                @UserstoreString = @UserstoreString + arguments[count]
            end
            count = count + 1
        end

        @userStoreCommandLine = Command.run(@userStoreStringFormation + ' ' + @UserstoreString)
        if @userStoreCommandLine.success?
            return true
        else
            return @userStoreCommandLine.stderr
        end
    end

    private :executeUserstoreCommandLine

	def ensureWorkspaceIsSelected (foldername)

		if !foldername.nil?
			@workspaceFolderName = foldername
		end

		if @workspaceWorkingDirectory.nil?
			return 'Cannot Create Workspace'
		else
			if Dir.exists?(@workspaceFolderName)
				regiInitialized = @workspaceFolderName + "/" + "._SYS_REGI_settings"
				if Dir.exists?(regiInitialized)
					return
				end
			else
				workspaceCreatorCommand = ['create','workspace',@workspaceFolderName,'--key=' + @hdbuserstoreKey,'--force']
				executeRegiCommandLine(workspaceCreatorCommand)
			end
		end
	end

	protected :ensureWorkspaceIsSelected

	def setKeystoreIfPresent

        if !@hdbuserstoreUser.nil? && !@hdbuserstorePassword.nil? && !@hdbuserstoreHost.nil? && !@hdbuserstorePort.nil?
            userstoreCreatorCommand = ['set',@hdbuserstoreKey,@hdbuserstoreHost + ':' + @hdbuserstorePort,@hdbuserstoreUser,@hdbuserstorePassword]
            executeUserstoreCommandLine(userstoreCreatorCommand)
        else
            return
        end
    end

    protected :setKeystoreIfPresent

    def ensureNotNull (parameter,parameterValue)

    	if parameterValue.nil?
    		return 'Value not specified for ' + parameter
    	end
    end

    protected :ensureNotNull

    def ensureNotNullOrEmpty (parameter,parameterValue)

    	if parameterValue.nil?
    		if parameter=='regiAction'
    			return 'help'
    		else
    			return ''
    		end
    	end
    end

    protected :ensureNotNullOrEmpty

    def commit

    	commitCommand = ['commit']
    	executeRegiCommandLineHandleException(commitCommand,false)
    end

    protected :commit

    def activate

    	activateCommand = ['activate']
    	executeRegiCommandLineHandleException(activateCommand,false)
    end

    protected :activate

    def checkout

    	checkoutHandleException(true)
    end

    protected :checkout

    def checkoutHandleException (ignoreException)

    	checkoutCommand = ['checkout']
    	executeRegiCommandLineHandleException(checkoutCommand,ignoreException)
    end

    private :checkoutHandleException

    def revert

    	revertHandleException(true)
    end

    protected :revert

    def revertHandleException (ignoreException)

    	revertCommand = ['revert']
    	executeRegiCommandLineHandleException(revertCommand,ignoreException)
    end

    private :revertHandleException

end