require 'Regiandruby/BaseClassRegi'
class RegiClean < BaseClassRegi

	@cleanDeliveryUnit = nil

	def setCleanDeliveryUnit
		@cleanDeliveryUnit = true
	end

	public :setCleanDeliveryUnit

	def doExecute (workspaceName)

		self.ensureNotNull('hdbUserstoreKey',self.gethdbUserstoreKey())

		self.initCommandLine()
		self.setKeystoreIfPresent()

		stdout = ''

		if Dir.exists?(workspaceName)
			require 'fileutils'
			FileUtils.rm_rf(workspaceName)
		end

		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do
				self.revert()
				self.commit()
				self.activate()

				if !self.getDeliveryUnit().nil?

					stdout = self.executeRegiCommandLineWithOutput(['list','deliveryUnit',deliveryUnit,'--vendor=' + self.getDeliveryUnitVendor()])

					if stdout!=''
						packages = stdout.split(/\r?\n\t/)
						
						count = 0
						while count<packages.length do
							deletePackage(packages[count],self.gethdbUserstoreKey())
							count = count + 1
						end

						if !@cleanDeliveryUnit.nil?
							deleteDeliveryUnit(self.getDeliveryUnit(),self.gethdbUserstoreKey())
						end
					else
						if !@cleanDeliveryUnit.nil?
							deleteDeliveryUnit(self.getDeliveryUnit(),self.gethdbUserstoreKey())
						end
					end
				else
					if !self.getPackageName().nil?
						deletePackage(self.getPackageName(),self.gethdbUserstoreKey())
					end

					mPackageNames = self.getPackageNames()

					if !mPackageNames.nil? && mPackageNames.length>0
						count = 0
						while count<mPackageNames.length do
							subPackageName = mPackageNames[count]
							deletePackage(subPackageName,self.gethdbUserstoreKey())
							count = count + 1
						end
					end
				end
			end
		end
		return true
	end

	public :doExecute

	def deletePackage (packageName,hdbUserstoreKey)
		self.executeRegiCommandLine(['delete','packages',packageName,'--key=' + hdbUserstoreKey,'--force'])
	end

	protected :deletePackage

	def deleteDeliveryUnit (deliveryUnit,hdbUserstoreKey)
		self.executeRegiCommandLine(['delete','deliveryUnit',deliveryUnit,'--vendor=' + self.getDeliveryUnitVendor(),'--key=' + hdbUserstoreKey,'--force'])
	end

	protected :deleteDeliveryUnit
end