require 'Regiandruby/BaseClassRegi'
class RegiCommitPackage < BaseClassRegi

	@revertPackages = nil
	@assignSubPackages = nil

	public 

	def doRevertPackages
		@revertPackages = true
	end

	def doassignSubPackages
		@assignSubPackages = true
	end
		
	def doExecute (workspaceName)

		self.ensureNotNull("hdbUserstoreKey",self.gethdbUserstoreKey())

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do

				if !@revertPackages.nil?
					self.revert()
				end

				packageName = self.getPackageName()

				if !packageName.nil?
					executeSub(packageName)
				end

				mPackageNames = self.getPackageNames()

				if !mPackageNames.nil? && mPackageNames.length>0
					count = 0
					while count<mPackageNames.length do
						subPackageName = mPackageNames[count]
						executeSub(subPackageName)
						count = count + 1
					end
				end
			end
		end
		return true
	end


	def executeSub (packageName)

		if self.executeRegiCommandLine(['track',packageName])!=true
			return false
		end

		self.commit()
		self.activate()

		deliveryUnit = self.getDeliveryUnit()
		deliveryUnitVendor = self.getDeliveryUnitVendor()

		if !deliveryUnit.nil?
			deliveryUnit = deliveryUnit.upcase

			command = 'package'
			if !@assignSubPackages.nil?
				command = 'packages'
			end

			if self.executeRegiCommandLine(['assign',command,packageName,'--deliveryUnit=' + deliveryUnit,'--vendor=' + deliveryUnitVendor,'--force'])!=true
				return false
			end

			if self.executeRegiCommandLine(['assign',packageName,deliveryUnit,'--vendor=' + deliveryUnitVendor])!=true
				return false
			end
		end

		self.executeRegiCommandLine(['untrack',packageName])	

		return true	
	end
end
