require 'Regiandruby/BaseClassRegi'
class RegiCreateDeliveryUnit < BaseClassRegi

	@deliveryUnitResponsible = nil

	@deliveryUnitACH =nil
	@deliveryUnitCaption = nil
	@deliveryUnitPPMSId = nil
	@deliveryUnitSpPPMSId = nil


	public

	def setDeliveryUnitResponsible (deliveryUnitResponsible)
		@deliveryUnitResponsible = deliveryUnitResponsible
	end

	def setDeliveryUnitACH (deliveryUnitACH)
		@deliveryUnitACH = deliveryUnitACH
	end

	def setDeliveryUnitCaption (deliveryUnitCaption)
		@deliveryUnitCaption = deliveryUnitCaption
	end

	def setDeliveryUnitPPMSId (deliveryUnitPPMSId)
		@deliveryUnitPPMSId = deliveryUnitPPMSId
	end

	def setDeliveryUnitSpPPMSId (deliveryUnitSpPPMSId)
		@deliveryUnitSpPPMSId = deliveryUnitSpPPMSId
	end

	def doExecute (workspaceName)

		self.ensureNotNull("hdbUserstoreKey",self.gethdbUserstoreKey())
		op = self.ensureNotNull("deliveryUnit",self.getDeliveryUnit())

		@deliveryUnitVersion = self.getDeliveryUnitVersion()
		@deliveryUnitVersionSP = self.getDeliveryUnitVersionSP()
		@deliveryUnitVersionPatch = self.getDeliveryUnitVersionPatch()

		if op!='Value not specified for deliveryUnit'
			deliveryUnit = self.getDeliveryUnit().upcase
		else
			return false
		end

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do
				deliveryUnitstr = self.executeRegiCommandLineWithOutput(['list','deliveryUnits'])

				if deliveryUnitstr!=''
					deliveryUnits = deliveryUnitstr.split(/\r?\n\t/)
				else
					return false
				end

				if !deliveryUnits.include?(deliveryUnit)
					if !@deliveryUnitVersion.nil?
						self.ensureNotNullOrEmpty("deliveryUnitResponsible",@deliveryUnitResponsible)
						self.ensureNotNullOrEmpty("deliveryUnitVersion",@deliveryUnitVersion)
						self.ensureNotNullOrEmpty("deliveryUnitVersionSP",@deliveryUnitVersionSP)
						self.ensureNotNullOrEmpty("deliveryUnitVersionPatch",@deliveryUnitVersionPatch)

						commandArray = ['create','deliveryUnit',deliveryUnit,'--responsible=' + @deliveryUnitResponsible,'--version=' + @deliveryUnitVersion,'--versionSP='+ @deliveryUnitVersionSP,'--versionPatch=' + @deliveryUnitVersionPatch,'--vendor=' + self.getDeliveryUnitVendor()]

						if !@deliveryUnitACH.nil?
							commandArray.push('--ach='+ @deliveryUnitACH)
						end
						if !@deliveryUnitCaption.nil?
							commandArray.push('--caption='+ @deliveryUnitCaption)
						end
						if !@deliveryUnitPPMSId.nil?
							commandArray.push('--ppmsID='+ @deliveryUnitPPMSId)
						end
						if !@deliveryUnitSpPPMSId.nil?
							commandArray.push('--spPPMSID='+ @deliveryUnitSpPPMSId)
						end

						if self.executeRegiCommandLine(commandArray)!=true
							return false
						else
							return true
						end
					else
						if self.executeRegiCommandLine(['create','deliveryUnit',deliveryUnit])!=true
							return false
						else
							return true
						end
					end
				end
			end
		end
	end
end