require 'Regiandruby/BaseClassRegi'
class RegiCreatePackage < BaseClassRegi

	public

	def doExecute (workspaceName)

		self.ensureNotNull("hdbUserstoreKey",self.gethdbUserstoreKey())
		self.ensureNotNull("package",self.getPackageName())

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)


		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do
				packageName = self.getPackageName()

				if !packageName.nil?
					executeSub(packageName)
				end

				mPackageNames = self.getPackageNames()

				if !mPackageNames.nil? && mPackageNames.length>0
					count = 0
					while count<mPackageNames.length do
						subPackageName = mPackageNames[count]
						executeSub(subPackageName)
						count = count + 1
					end
				end
			end
		end

		return true
	end

	def executeSub (packageName)

		regiOutput = self.executeRegiCommandLineWithOutput(['list','packages','--package=' + packageName])

		if regiOutput==''
			if self.executeRegiCommandLine(['create','package',packageName,'--force'])!=true
				return false
			end
		end

		deliveryUnit = self.getDeliveryUnit()
		deliveryUnitVendor = self.getDeliveryUnitVendor()

		if !deliveryUnit.nil?
			deliveryUnit = deliveryUnit.upcase

			if self.executeRegiCommandLine(['assign','package',packageName,deliveryUnit,'--vendor=' + deliveryUnitVendor])!=true
				return false
			end
		end

		self.executeRegiCommandLine(['untrack',packageName])
		return true
	end
end