require 'Regiandruby/BaseClassRegi'
class RegiExportDeliveryUnit < BaseClassRegi

	@deliveryUnitFileName = nil
	@nameVersionSeparator = nil
	@alias = nil

	@targetFolder = nil

	public

	def setDeliveryUnitFileName (deliveryUnitFileName)
		@deliveryUnitFileName = deliveryUnitFileName
	end

	def setNameVersionSeparator (nameVersionSeparator)
		@nameVersionSeparator = nameVersionSeparator
	end

	def setAlias (aliasname)
		@alias = aliasname
	end

	def setTargetFolderName (foldername)
		@targetFolder = foldername
	end

	def doExecute (workspaceName)

		@deliveryUnitVersion = self.getDeliveryUnitVersion()
		@deliveryUnitVersionSP = self.getDeliveryUnitVersionSP()
		@deliveryUnitVersionPatch = self.getDeliveryUnitVersionPatch()


		self.ensureNotNull("hdbUserstoreKey",self.gethdbUserstoreKey())
		op = self.ensureNotNull("deliveryUnit",self.getDeliveryUnit())
		self.ensureNotNull("deliveryUnitVersion",@deliveryUnitVersion)
		self.ensureNotNull("deliveryUnitVendor",self.getDeliveryUnitVendor())

		if @nameVersionSeparator.nil?
			@nameVersionSeparator = '_'
		end

		if op!='Value not specified for deliveryUnit'
			deliveryUnit = self.getDeliveryUnit()
			deliveryUnit = deliveryUnit.upcase
		else
			return false
		end

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do
				deliveryUnitName = ''

				if @deliveryUnitFileName.nil? && !@nameVersionSeparator.nil? && !@deliveryUnitVersion.nil? && !@deliveryUnitVersionSP.nil? && !@deliveryUnitVersionPatch.nil?
					deliveryUnitName = deliveryUnitName + deliveryUnit + @nameVersionSeparator + @deliveryUnitVersion + "." + @deliveryUnitVersionSP + "." + @deliveryUnitVersionPatch
					deliveryUnitName = deliveryUnitName + ".tgz"
				else
					deliveryUnitName = @deliveryUnitFileName
				end 

				if !@targetFolder.nil?
					#because Ruby uses /..mentioned in http://stackoverflow.com/questions/597488/how-to-do-a-safe-join-pathname-in-ruby
					if !@alias.nil?
						if self.executeRegiCommandLine(['export',deliveryUnit,self.getDeliveryUnitVendor(),@targetFolder + '/' + deliveryUnitName,'--alias='+ @alias])!=true
							return false
						end
					else
						if self.executeRegiCommandLine(['export',deliveryUnit,self.getDeliveryUnitVendor(),@targetFolder + '/' + deliveryUnitName])!=true
							return false
						end
					end
				end
			end
		end
		return true
	end
end