require 'Regiandruby/BaseClassRegi'
class RegiImportDeliveryUnit < BaseClassRegi

	@update = nil
	@nameVersionSeparator = nil
	@deliveryUnitFileName = nil
	@useSnapshot = nil
	@verbose = nil
	@log = nil
	@forceRemove = nil
	@autoActivate = nil

	public

	def setUpdate
		@update = true
	end

	def setDeliveryUnitFileName (filename)
		@deliveryUnitFileName = filename
	end

	def setNameVersionSeparator (nameVersionSeparator)
		@nameVersionSeparator = nameVersionSeparator
	end

	def setUseSnapshot
		@useSnapshot = true
	end

	def setVerbose
		@verbose = true
	end

	def setLog
		@log = true
	end

	def setForceRemove
		@forceRemove = true
	end

	def setAutoActivate
		@autoActivate = true
	end

	def doExecute (workspaceName)

		@deliveryUnitVersion = self.getDeliveryUnitVersion()
		@deliveryUnitVersionSP = self.getDeliveryUnitVersionSP()
		@deliveryUnitVersionPatch = self.getDeliveryUnitVersionPatch()

		self.ensureNotNull('hdbUserstoreKey',self.gethdbUserstoreKey())
		op = self.ensureNotNull('deliveryUnit',self.getDeliveryUnit())
		self.ensureNotNull('deliveryUnitVersion',self.getDeliveryUnitVersion())

		if op!='Value not specified for deliveryUnit'
			deliveryUnit = self.getDeliveryUnit().upcase
		end

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do

				deliveryUnitstr = self.executeRegiCommandLineWithOutput(['list','deliveryUnits','--key=' + self.gethdbUserstoreKey()])

				install = true

				if deliveryUnitstr!=''
					deliveryUnits = deliveryUnitstr.split(/\r?\n\t/)

					if !deliveryUnits.include?(deliveryUnit)
						install = true
					else
						if @update.nil?
							install = true
						else
							install = false
						end
					end
				end

				if install==true

					args = Array.new
					args.push('import')

					deliveryUnitName = ''

					if @deliveryUnitFileName.nil? && !@nameVersionSeparator.nil? && !@deliveryUnitVersion.nil? && !@deliveryUnitVersionSP.nil? && !@deliveryUnitVersionPatch.nil?
						deliveryUnitName = deliveryUnitName + @nameVersionSeparator + @deliveryUnitVersion + "." + @deliveryUnitVersionSP + "." + @deliveryUnitVersionPatch
						if !@useSnapshot.nil?
							deliveryUnitName = deliveryUnitName + '-SNAPSHOT'
						end
						deliveryUnitName = deliveryUnitName + '.tgz'
					elsif !@deliveryUnitFileName.nil?
						deliveryUnitName = @deliveryUnitFileName
					end

					args.push(deliveryUnitName)

					if !@verbose.nil?
						args.push('--verbose')
					end

					if !@log.nil?
						args.push('--log')
					end

					if !@forceRemove.nil?
						args.push('--forceRemove=1')
					else
						args.push('--forceRemove=0')
					end

					if !@autoActivate.nil?
						args.push('--autoActivate=1')
					else
						args.push('--autoActivate=0')
					end

					args.push('--key=' + self.gethdbUserstoreKey())

					if self.executeRegiCommandLine(args)!=true
						return false
					end
				end
			end
		end
		return true
	end
end