require 'Regiandruby/BaseClassRegi'
class RegiUndeployDeliveryUnit < BaseClassRegi

	@verbose = nil

	public

	def setVerbose
		@verbose = true
	end

	def doExecute (workspaceName)

		self.ensureNotNull('hdbUserstoreKey',self.gethdbUserstoreKey())
		op = self.ensureNotNull('deliveryUnit',self.getDeliveryUnit())

		if op!='Value not specified for deliveryUnit'
			deliveryUnit = self.getDeliveryUnit().upcase
		else
			return false
		end

		self.initCommandLine()
		self.setKeystoreIfPresent()
		self.ensureWorkspaceIsSelected(workspaceName)

		if Dir.exists?(workspaceName)
			Dir.chdir(workspaceName) do
				deliveryUnitstr = self.executeRegiCommandLineWithOutput(['list','deliveryUnits','--key='+ self.gethdbUserstoreKey()])

				undeploy = true

				if deliveryUnitstr!=''
					deliveryUnits = deliveryUnitstr.split(/\r?\n\t/)
				else
					return false
				end

				if !deliveryUnits.include?(deliveryUnit)
					undeploy = false
				else
					undeploy = true
				end

				if undeploy==true
					args = Array.new
					args.push('undeploy')

					args.push(deliveryUnit)
					args.push('--key=' + self.gethdbUserstoreKey())

					if !self.getDeliveryUnitVendor().nil?
						args.push('--vendor=' + self.getDeliveryUnitVendor())
					end

					if !@verbose.nil?
						args.push('--verbose')
					end

					if self.executeRegiCommandLine(args)!=true
						return false
					end
				end
			end
		end
		return true
	end
end